--SYS:
select  * from dba_scheduler_external_dests;
select  * from dba_scheduler_db_dests;
select * from dba_scheduler_dests;

/*
Next we define the database destination. The agent parameter should reference the destination name associated with the remote agent. If the tns_name parameter is NULL, the default instance on the remote host is assumed. This default instance is defined by the ORACLE_SID and ORACLE_HOME parameters in the "schagent.conf" file on the remote server. If a tns_name is specified, it can either be a complete Oracle Net connect descriptor, or a regular alias, but it must be resolvable on the database running the scheduler, not just the remote host.
*/

create_database_destination
创建目标数据库，用于执行远程job
AGENT——The external destination name of the Scheduler agent to connect. Equivalent to an agent name.
       The external destination must already exist. The external destination representing an agent is
       created automatically on a database instance when the agent registers with that instance.
       An agent‘s name is specified in its agent configuration file. If it is not specified, it defaults
       to the first part (before the first period) of the name of the host it resides on.

DBMS_SCHEDULER.CREATE_DATABASE_DESTINATION (
   destination_name        IN VARCHAR2,--目标数据库名称
   agent                   IN VARCHAR2,--代理名称，事先创建好的
   tns_name                IN VARCHAR2,--tns名称
   comments                IN VARCHAR2 DEFAULT NULL);

drop_database_destination
drop_agent_destination

begin
   dbms_scheduler.create_database_destination(
   destination_name => 'db199',
   agent => 'station199',tns_name => 'orcl199');
end

begin
   dbms_scheduler.create_database_destination(destination_name => 'db199utf',agent => 'station199',
   tns_name => '(DESCRIPTION = (ADDRESS = (PROTOCOL = TCP)(HOST = 192.168.0.199)(PORT = 1521)) (CONNECT_DATA = (SERVER = DEDICATED) (SERVICE_NAME = utforcl.example.com)))');
   end;
   
begin
   dbms_scheduler.create_database_destination(destination_name => 'db199orcl',agent => 'station199',
   tns_name => '(DESCRIPTION = (ADDRESS = (PROTOCOL = TCP)(HOST = 192.168.0.199)(PORT = 1521)) (CONNECT_DATA = (SERVER = DEDICATED) (SERVICE_NAME = orcl.example.com)))');
end;
 
begin
  dbms_scheduler.create_credential(
        credential_name => 'credential3',
        username => 'hr',
        password => 'hr');
end;

grant execute on credential3 to hr;
grant all on db199 to hr;
grant all on db199utl to hr;
grant all on db199orcl to hr;

--HR:
BEGIN
 sys.dbms_scheduler.create_job(
 job_name => 'hr.job13',
 job_type => 'STORED_PROCEDURE',
 job_action => 'hr.procremotedb_win',
 start_date => systimestamp at time zone 'PRC',
 job_class => '"DEFAULT_JOB_CLASS"',
 comments => 'job13',
 auto_drop => FALSE,
 enabled => FALSE,
 credential_name => 'sys.credential3',
 destination_name => 'db199');
end;

begin
 sys.dbms_scheduler.enable( 'hr.job13' );
END;


BEGIN
 sys.dbms_scheduler.create_job(
 job_name => 'hr.job131', 
 job_type => 'PLSQL_BLOCK',
 job_action => 'begin
   update employees set salary=salary+1  where employee_id=100;
   commit;
 end;',
 start_date => systimestamp at time zone 'Asia/Shanghai',
 job_class => '"DEFAULT_JOB_CLASS"',
 comments => 'JOB131',
 auto_drop => FALSE,
 credential_name =>'"SYS"."CREDENTIAL3"' ,destination_name =>'db199' ,
 enabled => true);
END;
